﻿/************************************************************************************

Copyright   :   Copyright 2017 Oculus VR, LLC. All Rights reserved.

Licensed under the Oculus VR Rift SDK License Version 3.4.1 (the "License");
you may not use the Oculus VR Rift SDK except in compliance with the License,
which is provided at the time of installation or download, or which
otherwise accompanies this software in either electronic or hard copy form.

You may obtain a copy of the License at

https://developer.oculus.com/licenses/sdk-3.4.1


Unless required by applicable law or agreed to in writing, the Oculus VR SDK
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

************************************************************************************/

using UnityEngine;
using System.Collections;
using UnityEngine.Events;
using System;
using UnityEngine.EventSystems;

public class OVRUserPanel : MonoBehaviour {

    [Serializable]
    public class ActivePanelEvent : UnityEvent<GameObject> { }

    [SerializeField]
    private ActivePanelEvent _onActivePanelChanged = new ActivePanelEvent();
    public ActivePanelEvent onActivePanelChanged { get { return _onActivePanelChanged; } set { _onActivePanelChanged = value; } }

    [Tooltip("File containing documentation for this context")]
    public string docFile;
	
	void OnEnable()
    {
        _onActivePanelChanged.Invoke(gameObject);
        if (OVRInspector.instance)
        {
            if (docFile != null && docFile.Length > 0)
            {
                OVRInspector.instance.SetDocTextFromFile(docFile);
            }
        }
    }
}
